package MyRC4;

use 5.008008;
use strict;
use warnings;

require Exporter;

our @ISA = qw(Exporter);

# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.

# This allows declaration	use MyRC4 ':all';
# If you do not need this, moving things directly into @EXPORT or @EXPORT_OK
# will save memory.
our %EXPORT_TAGS = ( 'all' => [ qw(
	
) ] );

our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );

our @EXPORT = qw(
	RC4
);

our $VERSION = '0.01';

require XSLoader;
XSLoader::load('MyRC4', $VERSION);

# Preloaded methods go here.

1;
__END__
# Below is stub documentation for your module. You'd better edit it!

=head1 NAME

MyRC4 - Perl extension for the RC4 encryption algorithm

=head1 SYNOPSIS

# Functional Style
  use MyRC4;
  $encrypted = RC4( $passphrase, $plaintext );
  $decrypt = RC4( $passphrase, $encrypted );

# OO Style
  use MyRC4;
  $ref = MyRC4->new( $passphrase );
  $encrypted = $ref->RC4( $plaintext );

  $ref2 = MyRC4->new( $passphrase );
  $decrypted = $ref2->RC4( $encrypted );

=head1 DESCRIPTION

A simple implementation of the RC4 algorithm, developed by RSA Security, Inc. Here is the description
from RSA's website:

RC4 is a stream cipher designed by Rivest for RSA Data Security (now RSA Security). It is a variable
key-size stream cipher with byte-oriented operations. The algorithm is based on
the use of a random
permutation. Analysis shows that the period of the cipher is overwhelmingly likely to be greater than
10100. Eight to sixteen machine operations are required per output byte, and the cipher can be
expected to run very quickly in software. Independent analysts have scrutinized
the algorithm and it
is considered secure.

=head2 EXPORT

RC4

=head1 SEE ALSO

L<perl>, L<http://www.cypherspace.org>, L<http://www.rsasecurity.com>, 
L<http://www.achtung.com/crypto/rc4.html>, 
L<http://www.columbia.edu/~ariel/ssleay/rrc4.html>
L<Crypt::RC4(3)>

=head1 AUTHOR

Tomoyuki Murakami, E<lt>tomoyuki at pobox dot comE<gt>

=head1 COPYRIGHT AND LICENSE

Copyright (C) 2008 by Tomoyuki Murakami

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself, either Perl version 5.8.8 or,
at your option, any later version of Perl 5 you may have available.


=cut
